<?php
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
/**
* The ps_tqgwdbe class, containing the payment processing code
*  for transactions with tqgwdbe.net 
*
* @version $Id: ps_tqgwdbe.php 958 2007-09-26 08:57:15Z soeren_nb $
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2004-2005 Soeren Eberhardt. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*/

class ps_tqgwdbe {

	var $payment_code = "TQGW";
	var $classname = "ps_tqgwdbe";

	/**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
	function show_configuration() {

		global $VM_LANG, $sess;
		$db =& new ps_DB;
		$payment_method_id = mosGetParam( $_REQUEST, 'payment_method_id', null );
		/** Read current Configuration ***/
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
    ?>
      <table>
        <tr>
            <td><strong><?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_QUANTUMGATEWAY_USERNAME ?></strong></td>
            <td>
                <input type="text" name="TQGW_LOGIN" class="inputbox" value="<?php echo TQGW_LOGIN ?>" />
            </td>
            <td><?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_QUANTUMGATEWAY_USERNAME_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_QUANTUMGATEWAY_KEY ?></strong></td>
            <td>
            <input type="text" name="TQGW_TRANSACTION_KEY" class="inputbox" value="<?php echo TQGW_TRANSACTION_KEY ?>" />
            </td>
            <td><?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_QUANTUMGATEWAY_KEY_EXPLAIN ?></td>
        </tr>
        <tr>
            <td><strong><?php echo $VM_LANG->_PHPSHOP_PAYMENT_CVV2 ?></strong></td>
            <td>
                <select name="TQGW_CHECK_CARD_CODE" class="inputbox">
                <option <?php if (TQGW_CHECK_CARD_CODE == 'YES') echo "selected=\"selected\""; ?> value="YES">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_YES ?></option>
                <option <?php if (TQGW_CHECK_CARD_CODE == 'NO') echo "selected=\"selected\""; ?> value="NO">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_NO ?></option>
                </select>
            </td>
            <td><?php echo $VM_LANG->_PHPSHOP_PAYMENT_CVV2_TOOLTIP ?></td>
        </tr>
        <tr><td colspan="3"><hr/></td></tr>
        <tr>
            <td><strong>Order Status for successful transactions</strong></td>
            <td>
                <select name="TQGW_VERIFIED_STATUS" class="inputbox" >
                <?php
                $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
                $db->query($q);
                $order_status_code = Array();
                $order_status_name = Array();

                while ($db->next_record()) {
                	$order_status_code[] = $db->f("order_status_code");
                	$order_status_name[] =  $db->f("order_status_name");
                }
                for ($i = 0; $i < sizeof($order_status_code); $i++) {
                	echo "<option value=\"" . $order_status_code[$i];
                	if (TQGW_VERIFIED_STATUS == $order_status_code[$i])
                	echo "\" selected=\"selected\">";
                	else
                	echo "\">";
                	echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td>Select the order status to which the actual order is set, if the Quantum Gateway  Transaction was successful. 
            If using download selling options: select the status which enables the download (then the customer is instantly notified about the download via e-mail).
            </td>
        </tr>
            <tr>
            <td><strong>Order Status for failed transactions</strong></td>
            <td>
                <select name="TQGW_INVALID_STATUS" class="inputbox" >
                <?php
                for ($i = 0; $i < sizeof($order_status_code); $i++) {
                	echo "<option value=\"" . $order_status_code[$i];
                	if (TQGW_INVALID_STATUS == $order_status_code[$i])
                	echo "\" selected=\"selected\">";
                	else
                	echo "\">";
                	echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td>Select an order status for failed Quantum Gateway transactions.</td>
        </tr>

            <tr>
            <td><strong>Show Response Codes for Failed Transactions?</strong></td>
            <td>
                <select name="TQGW_SHOW_ERROR_CODE" class="inputbox">
                <option <?php if (TQGW_SHOW_ERROR_CODE == 'YES') echo "selected=\"selected\""; ?> value="YES">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_YES ?></option>
                <option <?php if (TQGW_SHOW_ERROR_CODE == 'NO') echo "selected=\"selected\""; ?> value="NO">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_NO ?></option>
                </select>
            </td>
            <td>If set to YES then the customer will see the Authorize.net Transaction Response Reason Codes (Response Code - 
				Response Subcode - Response Reason Code - AVS Result Code - Card Code (CVV2/CVC2/CID) Response Code - 
				Cardholder Authentication Verification Value (CAVV) Response Code - in a format like: 2-2-65-Y-N--)
				along with the Response Reason Text. This can be useful for troubleshooting failed or declined transactions.
				For further details see the <a href="https://secure.quantumgateway.com/TQGW-Interactive_API.pdf">Quantum Gateway database Engine (TQGWdbe) Implementation Guide</a></td>
        </tr>
        <tr>
            <td><strong>Email Confirmation from Gateway to Merchant?</strong></td>
            <td>
                <select name="TQGW_EMAIL_MERCHANT" class="inputbox">
                <option <?php if (TQGW_EMAIL_MERCHANT == 'YES') echo "selected=\"selected\""; ?> value="YES">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_YES ?></option>
                <option <?php if (TQGW_EMAIL_MERCHANT == 'NO') echo "selected=\"selected\""; ?> value="NO">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_NO ?></option>
                </select>
            </td>
            <td>Send copy of the customer confirmation email to the Merchant? If yes then an email will
				be sent to the Merchant address as well as the address(es) configured in the Merchant Interface.
				<em> Note: this email is sent from the Authorize.net gateway and is independent of any email sent by VirtueMart</em> 
            </td>
        </tr>
        <tr>
            <td><strong>Email Confirmation from Gateway to Customer?</strong></td>
            <td>
                <select name="TQGW_EMAIL_CUSTOMER" class="inputbox">
                <option <?php if (TQGW_EMAIL_CUSTOMER == 'YES') echo "selected=\"selected\""; ?> value="YES">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_YES ?></option>
                <option <?php if (TQGW_EMAIL_CUSTOMER == 'NO') echo "selected=\"selected\""; ?> value="NO">
                <?php echo $VM_LANG->_PHPSHOP_ADMIN_CFG_NO ?></option>
                </select>
            </td>
            <td>Send a confirmation email to the customer? If yes then an email will
				be sent to the customer from the Merchant Interface.
				<em> Note: this email is sent from the Authorize.net gateway and is independent of any email sent by VirtueMart</em> 
            </td>
        </tr>
      </table>
   <?php
   // return false if there's no configuration
   return true;
	}

	function has_configuration() {
		// return false if there's no configuration
		return true;
	}

	/**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
	function configfile_writeable() {
		return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	/**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
	function configfile_readable() {
		return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}
	/**
	* Writes the configuration file for this payment method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
	function write_configuration( &$d ) {

		$my_config_array = array("TQGW_LOGIN" => $d['TQGW_LOGIN'],
		"TQGW_CHECK_CARD_CODE" => $d['TQGW_CHECK_CARD_CODE'],
		"TQGW_VERIFIED_STATUS" => $d['TQGW_VERIFIED_STATUS'],
		"TQGW_INVALID_STATUS" => $d['TQGW_INVALID_STATUS'],
		"TQGW_EMAIL_MERCHANT" => $d['TQGW_EMAIL_MERCHANT'],
		"TQGW_EMAIL_CUSTOMER" => $d['TQGW_EMAIL_CUSTOMER'],
		"TQGW_SHOW_ERROR_CODE" => $d['TQGW_SHOW_ERROR_CODE'],
		"TQGW_TRANSACTION_KEY" => $d['TQGW_TRANSACTION_KEY']
		);
		$config = "<?php\n";
		$config .= "defined('_VALID_MOS') or die('Direct Access to this location is not allowed.'); \n\n";
		foreach( $my_config_array as $key => $value ) {
			$config .= "define ('$key', '$value');\n";
		}

		$config .= "?>";

		if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
                        fclose ($fp);
                        return true;
                }
                else {
                        return false;
                }
        }

        /**************************************************************************
        ** name: process_payment()
	** created by: Soeren
	** description: process transaction with Quantum Gateway
	** parameters: $order_number, the number of the order, we're processing here
	**            $order_total, the total $ of the order
	** returns:
	***************************************************************************/
	function process_payment($order_number, $order_total, &$d) {

		global $vendor_mail, $vendor_currency, $VM_LANG, $vmLogger;
		$database = new ps_DB;
		$ps_vendor_id = $_SESSION["ps_vendor_id"];
		$auth = $_SESSION['auth'];
		$ps_checkout = new ps_checkout;

		/*** Get the Configuration File for Quantum Gateway ***/
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");


		// Get user billing information
		$dbbt = new ps_DB;

		$qt = "SELECT * FROM #__{vm}_user_info WHERE user_id=".$auth["user_id"]." AND address_type='BT'";

		$dbbt->query($qt);
		$dbbt->next_record();
		$user_info_id = $dbbt->f("user_info_id");
		if( $user_info_id != $d["ship_to_info_id"]) {
			// Get user billing information
			$dbst =& new ps_DB;
			$qt = "SELECT * FROM #__{vm}_user_info WHERE user_info_id='".$d["ship_to_info_id"]."' AND address_type='ST'";
			$dbst->query($qt);
			$dbst->next_record();
		}
		else {
			$dbst = $dbbt;
		}
		$host = 'secure.quantumgateway.com';
		$port = 443;
		$path = "/cgi/tqgwdbe.php";
		// Option to send email to merchant from gateway
		if (TQGW_EMAIL_MERCHANT == 'NO') {
				$vendor_mail = "N";
 		}
		if (TQGW_EMAIL_MERCHANT == 'YES') {
				$vendor_mail = "Y";
 		}
		if (TQGW_EMAIL_CUSTOMER == 'YES') {
			$email_customer = "Y";
		} else {
			$email_customer = "N";
 		}
/*	Type Of CVV2 being sent - CVVtype
0 - Not Passing CVV2
1 - CVV2 is being passed
2 - CVV2 on card is unreadable
9 - Card does not have CVV2 imprint
*/
	
		if (TQGW_CHECK_CARD_CODE == "YES") {
			$cvvtype = "1";
		} else {
			$cvvtype = "0";
		}		
		//Quantum Gateway vars to send
		$formdata = array (
		'gwlogin' => TQGW_LOGIN,
		


		// Customer Name and Billing Address
		'FNAME' => substr($dbbt->f("first_name"), 0, 50),
		'LNAME' => substr($dbbt->f("last_name"), 0, 50),
		'BADDR1' => substr($dbbt->f("address_1"), 0, 60),
		'BCITY' => substr($dbbt->f("city"), 0, 40),
		'BSTATE' => substr($dbbt->f("state"), 0, 40),
		'BZIP1' => substr($dbbt->f("zip"), 0, 20),
		'BCOUNTRY' => substr($dbbt->f("country"), 0, 60),
		'phone' => substr($dbbt->f("phone_1"), 0, 25),
		'fax' => substr($dbbt->f("fax"), 0, 25),

		// Customer Shipping Address
		'SFNAME' => substr($dbst->f("first_name"), 0, 50),
		'SLNAME' => substr($dbst->f("last_name"), 0, 50),
		'SADDR1' => substr($dbst->f("address_1"), 0, 60),
		'SCITY' => substr($dbst->f("city"), 0, 40),
		'SSTATE' => substr($dbst->f("state"), 0, 40),
		'SZIP1' => substr($dbst->f("zip"), 0, 20),
		'SCOUNTRY' => substr($dbst->f("country"), 0, 60),

		// Additional Customer Data
		'cust_id' => $auth['user_id'],


		// Email Settings
		'BCUST_EMAIL' => $dbbt->f("user_email"),
		'override_email_customer' => $email_customer,
		'override_trans_email' => $vendor_mail,

		// Invoice Information
		'invoice_num' => substr($order_number, 0, 20),
		'invoice_description' => $VM_LANG->_PHPSHOP_ORDER_PRINT_PO_LBL,

		// Transaction Data
		'amount' => $order_total,
		'ccnum' => $_SESSION['ccdata']['order_payment_number'],
		'ccmo' => ($_SESSION['ccdata']['order_payment_expire_month']),
		'ccyr' => ($_SESSION['ccdata']['order_payment_expire_year']),
		'salesTaxAmount' => substr($d['order_tax'], 0, 15),
		);
		if ($cvvtype == "1") {
			if ($_SESSION['ccdata']['credit_card_code'] != "") {
				$formdata['CVV2'] = $_SESSION['ccdata']['credit_card_code'];
			} else {
				$cvvtype = "2";	
			}
		}
		$formdata['CVVtype'] = $cvvtype;
		
		if (TQGW_TRANSACTION_KEY != '') {
			$formdata['RestrictKey'] = TQGW_TRANSACTION_KEY;
		}
		//build the post string
		$poststring = '';
		foreach($formdata AS $key => $val){
			$poststring .= urlencode($key) . "=" . urlencode($val) . "&";
		}
		// strip off trailing ampersand
		$poststring = substr($poststring, 0, -1);

		if( function_exists( "curl_init" )) {

			$vmLogger->debug( 'Using the cURL library for communicating with '.$host );



			$CR = curl_init();
			curl_setopt($CR, CURLOPT_URL, "https://".$host.$path);
			$agent = "Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.4) Gecko/20030624 Netscape/7.1 (affgrabber)";
			curl_setopt($CR, CURLOPT_USERAGENT, $agent);
			curl_setopt($CR, CURLOPT_POST, 1);
			curl_setopt($CR, CURLOPT_UNRESTRICTED_AUTH, 1);
			curl_setopt($CR, CURLOPT_HTTPAUTH, CURLAUTH_ANYSAFE);
			curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($CR, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($CR, CURLOPT_SSLVERSION, 6);
			curl_setopt($CR, CURLOPT_POSTFIELDS, $poststring);


			// No PEER certificate validation...as we don't have
			// a certificate file for it to authenticate the host www.ups.com against!
			curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 0);
			//curl_setopt($CR, CURLOPT_SSLCERT , "/usr/locale/xxxx/clientcertificate.pem");

			$result = curl_exec( $CR );

			$error = curl_error( $CR );
			if( !empty( $error )) {
				$vmLogger->err( $error );
				$html = "<br/><span class=\"message\">".$VM_LANG->_PHPSHOP_PAYMENT_INTERNAL_ERROR." Quantum Gateway</span>:::" . print_r($error) . "::: ";
				return false;
			}
			else {
				//echo $result; exit();
			}
			curl_close( $CR );
		}
		else {
			$vmLogger->debug( 'Starting communication with '.$host.' without cURL library.');

			$fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
			if(!$fp){
				//error tell us
				$vmLogger->err( "Possible server error! - $errstr ($errno)\n" );
			}
			else {
				$vmLogger->debug( 'Connection opened to '.$host.', now posting the variables.');

				//send the server request
				fputs($fp, "POST $path HTTP/1.1\r\n");
				fputs($fp, "Host: $host\r\n");
				fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
				fputs($fp, "Content-length: ".strlen($poststring)."\r\n");
				fputs($fp, "Connection: close\r\n\r\n");
				fputs($fp, $poststring . "\r\n\r\n");

				//Get the response header from the server
				$str = '';
				while(!feof($fp) && !stristr($str, 'content-length')) {
					$str = fgets($fp, 4096);
				}
				// If didnt get content-lenght, something is wrong, return false.
				if (!stristr($str, 'content-length')) {
					$vmLogger->err('An error occured while communicating with the Quantum Gateway server. It didn\'t reply (correctly). Please try again later, thank you.' );
					return false;
				}
				$data = "";
				while (!feof($fp)) {
					$data .= fgets ($fp, 1024);
				}
				$result = trim( $data );
				/*
				// Get length of data to be received.
				$length = trim(substr($str,strpos($str,'content-length') + 15));
				// Get buffer (blank data before real data)
				fgets($fp, 4096);
				// Get real data
				$data = fgets($fp, $length);
				fclose($fp);*/

			}
		}
		$response = explode(",", $result);
		// Strip off quotes from the first response field
		for ($i=0; $i<count($response); $i++) {
			$response[$i] = trim(str_replace( '"', '', $response[$i]));
		}            
		$vmLogger->debug('Beginning to analyse the response from '.$host );
		//echo "aa" .$response[0] ."aa"; exit;
		// Approved - Success!
		if ($response[0] == "APPROVED") {
			//echo "aprove"; exit;
			$d["order_payment_log"] = $VM_LANG->_PHPSHOP_PAYMENT_TRANSACTION_SUCCESS.": ";
			$d["order_payment_log"] .= $response[0];

			$vmLogger->debug( $d['order_payment_log']);

			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response[2];

			return True;
		}
		// Payment Declined
		elseif ($response[0] == 'DECLINED') {

/*
Response Sequence: Transaction Status, Auth Code, Transaction ID, AVS Response, CVV2 Response, Maxmind Score, Decline Reason, Decline Error Number
"APPROVED","019452","652145","Y","M","0.6"
"DECLINED","019452","652145","N","N","0.6","INVALID EXP DATE","205"
*/

			if (TQGW_SHOW_ERROR_CODE == 'YES') {
				$vmLogger->err( $response[0] . "-" . $response[1] . "-" . $response[2] . "-" .  $response[3] . "-" . $response[4] . "-" . $response[6] . "-" . $response[7] );
			} else {
				$vmLogger->err( $response[0] );
			}

			$d["order_payment_log"] = $response[0];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response[2];
			return False;
		}
		// Transaction Error
	}

	/**************************************************************************
	** name: capture_payment()
	** created by: Soeren
	** description: Process a previous transaction with Quantum Gateway, Capture the Payment
	** parameters: $order_number, the number of the order, we're processing here
	** returns:
	***************************************************************************/
	function capture_payment( &$d ) {

		global $vendor_mail, $vendor_currency, $VM_LANG, $vmLogger;
		$database = new ps_DB();

		/*CERTIFICATION
		Visa Test Account           4007000000027
		Amex Test Account           370000000000002
		Master Card Test Account    6011000000000012
		Discover Test Account       5424000000000015

		*/
		if( empty($d['order_number'])) {
			$vmLogger->err("Error: No Order Number provided.");
			return false;
		}
		/*** Get the Configuration File for Quantum Gateway ***/
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");

		$host = 'secure.quantumgateway.com';
		$port = 443;
		$path = "/cgi/tqgwdbe.php";
		
		$db = new ps_DB;
		$q = "SELECT * FROM #__{vm}_orders, #__{vm}_order_payment WHERE ";
		$q .= "order_number='".$d['order_number']."' ";
		$q .= "AND #__{vm}_orders.order_id=#__{vm}_order_payment.order_id";
		$db->query( $q );
		if( !$db->next_record() ) {
			$vmLogger->err("Error: Order not found.");
			return false;
		}
		$expire_date = date( "my", $db->f("order_payment_expire") );

		// DECODE Account Number
		$dbaccount = new ps_DB;
		$q = "SELECT DECODE(order_payment_number,'".ENCODE_KEY."')
          AS account_number from #__{vm}_order_payment WHERE order_id='".$db->f("order_id")."'";
		$dbaccount->query($q);
		$dbaccount->next_record();

		// Get user billing information
		$dbbt = new ps_DB;
		$qt = "SELECT * FROM #__{vm}_user_info WHERE user_id='".$db->f("user_id")."'";
		$dbbt->query($qt);
                $dbbt->next_record();
                $user_info_id = $dbbt->f("user_info_id");
                if( $user_info_id != $db->f("user_info_id")) {
                        // Get user's alternative shipping information
                        $dbst =& new ps_DB;
                        $qt = "SELECT * FROM #__{vm}_user_info WHERE user_info_id='".$db->f("user_info_id")."' AND address_type='ST'";
                        $dbst->query($qt);
			$dbst->next_record();
		}
		else {
			$dbst = $dbbt;
		}
		if (TQGW_EMAIL_MERCHANT == 'NO') {
				$vendor_mail = "N";
 		}
		if (TQGW_EMAIL_MERCHANT == 'YES') {
				$vendor_mail = "Y";
 		}
		if (TQGW_EMAIL_CUSTOMER == 'YES') {
			$email_customer = "Y";
		} else {
			$email_customer = "N";
 		}
/*	Type Of CVV2 being sent - CVVtype
0 - Not Passing CVV2
1 - CVV2 is being passed
2 - CVV2 on card is unreadable
9 - Card does not have CVV2 imprint
*/
	
		if (TQGW_CHECK_CARD_CODE == "YES") {
			$cvvtype = "1";
		} else {
			$cvvtype = "0";
		}		
		//Quantum Gateway vars to send
		$formdata = array (
		'gwlogin' => TQGW_LOGIN,
		


		// Customer Name and Billing Address
		'FNAME' => substr($dbbt->f("first_name"), 0, 50),
		'LNAME' => substr($dbbt->f("last_name"), 0, 50),
		'BADDR1' => substr($dbbt->f("address_1"), 0, 60),
		'BCITY' => substr($dbbt->f("city"), 0, 40),
		'BSTATE' => substr($dbbt->f("state"), 0, 40),
		'BZIP1' => substr($dbbt->f("zip"), 0, 20),
		'BCOUNTRY' => substr($dbbt->f("country"), 0, 60),
		'phone' => substr($dbbt->f("phone_1"), 0, 25),
		'fax' => substr($dbbt->f("fax"), 0, 25),

		// Customer Shipping Address
		'SFNAME' => substr($dbst->f("first_name"), 0, 50),
		'SLNAME' => substr($dbst->f("last_name"), 0, 50),
		'SADDR1' => substr($dbst->f("address_1"), 0, 60),
		'SCITY' => substr($dbst->f("city"), 0, 40),
		'SSTATE' => substr($dbst->f("state"), 0, 40),
		'SZIP1' => substr($dbst->f("zip"), 0, 20),
		'SCOUNTRY' => substr($dbst->f("country"), 0, 60),

		// Additional Customer Data
		'cust_id' => $auth['user_id'],


		// Email Settings
		'BCUST_EMAIL' => $dbbt->f("user_email"),
		'override_email_customer' => $email_customer,
		'override_trans_email' => $vendor_mail,

		// Invoice Information
		'invoice_num' => substr($order_number, 0, 20),
		'invoice_description' => $VM_LANG->_PHPSHOP_ORDER_PRINT_PO_LBL,

		// Transaction Data
		'amount' => $order_total,
		'ccnum' => $_SESSION['ccdata']['order_payment_number'],
		'ccmo' => ($_SESSION['ccdata']['order_payment_expire_month']),
		'ccyr' => ($_SESSION['ccdata']['order_payment_expire_year']),
		'salesTaxAmount' => substr($d['order_tax'], 0, 15),
		);
		if ($cvvtype == "1") {
			if ($_SESSION['ccdata']['credit_card_code'] != "") {
				$formdata['CVV2'] = $_SESSION['ccdata']['credit_card_code'];
			} else {
				$cvvtype = "2";	
			}
		}
		$formdata['CVVtype'] = $cvvtype;
		
		if (TQGW_TRANSACTION_KEY != '') {
			$formdata['RestrictKey'] = TQGW_TRANSACTION_KEY;
		}

		//build the post string
		$poststring = '';
		foreach($formdata AS $key => $val){
			$poststring .= urlencode($key) . "=" . urlencode($val) . "&";
		}
		// strip off trailing ampersand
		$poststring = substr($poststring, 0, -1);

		if( function_exists( "curl_init" )) {

			$CR = curl_init();
			curl_setopt($CR, CURLOPT_URL, "https://".$host.$path);
			$agent = "Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.4) Gecko/20030624 Netscape/7.1 (affgrabber)";
			curl_setopt($CR, CURLOPT_USERAGENT, $agent);
			curl_setopt($CR, CURLOPT_POST, 1);
			curl_setopt($CR, CURLOPT_UNRESTRICTED_AUTH, 1);
			curl_setopt($CR, CURLOPT_HTTPAUTH, CURLAUTH_ANYSAFE);
			curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($CR, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($CR, CURLOPT_POSTFIELDS, $poststring);

			// No PEER certificate validation...as we don't have
			// a certificate file for it to authenticate the host www.ups.com against!
			curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 0);
			//curl_setopt($CR, CURLOPT_SSLCERT , "/usr/locale/xxxx/clientcertificate.pem");

			$result = curl_exec( $CR );

			$error = curl_error( $CR );
			if( !empty( $error )) {
				$vmLogger->err( curl_error( $CR ) );
				$html = "<br/><span class=\"message\">".$VM_LANG->_PHPSHOP_PAYMENT_INTERNAL_ERROR." Quantum Gateway</span>:::" . print_r($error) . ":::";
				return false;
			}
			else {
				//echo $result; exit();
			}
			curl_close( $CR );
		}
		else {

			$fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
			if(!$fp){
				//error tell us
				$vmLogger->err("$errstr ($errno)");
			}
			else {

				//send the server request
				fputs($fp, "POST $path HTTP/1.1\r\n");
				fputs($fp, "Host: $host\r\n");
				fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
				fputs($fp, "Content-length: ".strlen($poststring)."\r\n");
				fputs($fp, "Connection: close\r\n\r\n");
				fputs($fp, $poststring . "\r\n\r\n");

				//Get the response header from the server
				$str = '';
				while(!feof($fp) && !stristr($str, 'content-length')) {
					$str = fgets($fp, 4096);
				}
				// If didnt get content-lenght, something is wrong, return false.
				if (!stristr($str, 'content-length')) {
					return false;

				}
				$data = "";
				while (!feof($fp)) {
					$data .= fgets ($fp, 1024);
				}
				$result = trim( $data );
				/*
				// Get length of data to be received.
				$length = trim(substr($str,strpos($str,'content-length') + 15));
				// Get buffer (blank data before real data)
				fgets($fp, 4096);
				// Get real data
				$data = fgets($fp, $length);
				fclose($fp);*/

			}
		}
		$response = explode(",", $result);
		// Strip off quotes from the first response field
		for ($i=0; $i<count($response); $i++) {
			$response[$i] = trim(str_replace( '"', '', $response[$i]));
		}  

		// Approved - Success!
		if ($response[0] == 'APPROVED') {
			$d["order_payment_log"] = $VM_LANG->_PHPSHOP_PAYMENT_TRANSACTION_SUCCESS.": ";
			$d["order_payment_log"] .= $response[0];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response[2];

			$q = "UPDATE #__{vm}_order_payment SET ";
			$q .="order_payment_log='".$d["order_payment_log"]."',";
			$q .="order_payment_trans_id='".$d["order_payment_trans_id"]."' ";
			$q .="WHERE order_id='".$db->f("order_id")."' ";
			$db->query( $q );

			return True;
		}
		// Payment Declined
		elseif ($response[0] == 'DECLINED') {
			$vmLogger->err($response[0]);
			$d["order_payment_log"] = $response[0];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response[2];
			return False;
		}
		
	}

}
